searchNodes=[{"ref":"EctoQueryString.html","title":"EctoQueryString","type":"module","doc":"Compose an Ecto.Query with a querystring Usage Say you have the following schemas: defmodule Foo do use Ecto.Schema schema &quot;foos&quot; do field(:name, :string) field(:age, :integer) has_many(:bars, Bar) end end defmodule Bar do use Ecto.Schema schema &quot;bars&quot; do field(:title, :string) field(:likes, :integer) belongs_to(:foo, Foo) end end You can do things like this: query = Ecto.Query.from(user in User) query_string = &quot;username=mrmicahcooper&amp;greater:age=18&amp;limit=10&quot; EctoQueryString.query(query, query_string) And get: Ecto.Query.from(u0 in User, where: u0.age &gt; ^&quot;18&quot;, where: u0.username == ^&quot;mrmicahcooper&quot;, limit: ^&quot;10&quot; ) Here is the full DSL # Basic Queries &quot;name=micah&quot; =&gt; where: foo.name = ^&quot;micah&quot; &quot;name=micah,bob&quot; =&gt; where: foo.name in ^[&quot;micah&quot;, &quot;bob&quot;] &quot;!name=micah&quot; =&gt; where: foo.name != ^&quot;micah&quot; &quot;!name=micah,bob&quot; =&gt; where: foo.name not in ^[&quot;micah&quot;, &quot;bob&quot;] &quot;like:foo=bar*&quot; =&gt; where: like(x.foo, ^&quot;bar%&quot;) &quot;like:foo=*bar&quot; =&gt; where: like(x.foo, ^&quot;%bar&quot;) &quot;like:name=*micah*&quot; =&gt; where: like(foo.name, ^&quot;%micah%&quot;) &quot;ilike:name=micah*&quot; =&gt; where: ilike(foo.name, ^&quot;micah%&quot;) &quot;ilike:name=*micah&quot; =&gt; where: ilike(foo.name, ^&quot;%micah&quot;) &quot;ilike:foo=*bar*&quot; =&gt; where: ilike(x.foo, ^&quot;%bar%&quot;) &quot;less:age=99&quot; =&gt; where: foo.age &lt; 99 &quot;greater:age=40&quot; =&gt; where: foo.age &gt; 40 &quot;range:age=40:99&quot; =&gt; where: foo.age &lt; 99 and foo.age &gt; 40 &quot;or:name=micah&quot; =&gt; or_where: foo.name = ^&quot;micah&quot; &quot;or:name=micah,bob&quot; =&gt; or_where: foo.name in ^[&quot;micah&quot;, &quot;bob&quot;] &quot;!or:name=bar&quot; =&gt; or_where: foo.name != ^&quot;bar&quot; &quot;!or:name=micah,bob&quot; =&gt; or_where: foo.name not in ^[&quot;bar&quot;, &quot;baz&quot;] &quot;select=foo,bar&quot; =&gt; select: [:foo, :bar] &quot;fields=foo,bar&quot; =&gt; select: [:foo, :bar] &quot;limit=.:99&quot; =&gt; limit: 99 &quot;offset=40:.&quot; =&gt; offset: 40 &quot;between=40:99&quot; =&gt; offset: 40, limit: 99 &quot;order=foo,-bar,baz&quot; =&gt; order_by: [asc: :foo, desc: :bar, asc: :baz] # Incorporating Associated Tables &quot;bars.title=micah&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.title = ^&quot;micah&quot; &quot;bars.title=micah,bob&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.title in ^[&quot;micah&quot;, &quot;bob&quot;] &quot;!bars.title=micah&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.title != ^&quot;micah&quot;) &quot;!bars.title=micah,bob&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.title not in ^[&quot;micah&quot;, &quot;bob&quot;]) &quot;like:bars.title=micah*&quot; =&gt; join: bars in assoc(foo, :bars), where: like(bars.title, ^&quot;bar%&quot;) &quot;like:bars.title=*micah&quot; =&gt; join: bars in assoc(foo, :bars), where: like(bars.title, ^&quot;%bar&quot;) &quot;like:bars.title=*micah*&quot; =&gt; join: bars in assoc(foo, :bars), where: like(bars.title, ^&quot;%bar%&quot;) &quot;ilike:bars.title=micah*&quot; =&gt; join: bars in assoc(foo, :bars), where: ilike(bars.title, ^&quot;micah%&quot;) &quot;ilike:bars.title=*micah&quot; =&gt; join: bars in assoc(foo, :bars), where: ilike(bars.title, ^&quot;%micah&quot;) &quot;ilike:bars.title=*micah* &quot; =&gt; join: bars in assoc(foo, :bars), where: ilike(bars.title, ^&quot;%micah%&quot;) &quot;less:bars.likes=99&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.likes &lt; 99 &quot;greater:bars.likes=99&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.likes &gt; 99 &quot;range:bars.likes=40:99&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.likes&lt; 99 and bars.likes &gt; 40 &quot;or:bars.title=micah&quot; =&gt; join: bars in assoc(foo, :bars), or_where: bars.title == ^&quot;micah&quot; &quot;or:bars.title=micah,bob&quot; =&gt; join: bars in assoc(foo, :bars), or_where: bars.title in ^[&quot;micah&quot;, &quot;bob&quot; &quot;!or:bars.title=micah&quot; =&gt; join: bars in assoc(foo, :bars), or_where: bars.title != ^&quot;micah&quot; &quot;!or:bars.title=micah,bob&quot; =&gt; join: bars in assoc(foo, :bars), or_where: bars.title not in ^[&quot;micah&quot;, &quot;bob&quot; &quot;select=email,bars.title&quot; =&gt; join: bars in assoc(foo, :bars), select: [{:bars, [:title]}, :email], preload: [:bars] # Maps and keyword lists are supported too %{&quot;ilike:foo&quot; =&gt; &quot;*bar*&quot;} =&gt; where: ilike(x.foo, ^&quot;%bar%&quot;) [name: &quot;micah&quot;] =&gt; where: foo.name = ^&quot;micah&quot;"},{"ref":"EctoQueryString.html#query/2","title":"EctoQueryString.query/2","type":"function","doc":"Uses a querystring or a map of params to extend an Ecto.Query This DSL provides basic query functions with the goal of handling the majority of your filtering, ordering, and basic selects."},{"ref":"EctoQueryString.html#selectable/2","title":"EctoQueryString.selectable/2","type":"function","doc":""},{"ref":"EctoQueryString.Reflection.html","title":"EctoQueryString.Reflection","type":"module","doc":"Provides some conveniences to work with Queries and Schemas You can use this module to make sure the passed in fields are valid for the Query /Schema"},{"ref":"EctoQueryString.Reflection.html#assoc_schema/2","title":"EctoQueryString.Reflection.assoc_schema/2","type":"function","doc":"Return an associated schema"},{"ref":"EctoQueryString.Reflection.html#field/2","title":"EctoQueryString.Reflection.field/2","type":"function","doc":"Get the :atom representation of a field if it exists in the passed in Ecto.Schema"},{"ref":"EctoQueryString.Reflection.html#foreign_key/2","title":"EctoQueryString.Reflection.foreign_key/2","type":"function","doc":"Return an the foreign key of a schema&#39;s association"},{"ref":"EctoQueryString.Reflection.html#has_assoc?/2","title":"EctoQueryString.Reflection.has_assoc?/2","type":"function","doc":"Check if an Ecto.Schema has the passed in association"},{"ref":"EctoQueryString.Reflection.html#has_field?/2","title":"EctoQueryString.Reflection.has_field?/2","type":"function","doc":"Check if an Ecto.Schema has the passed in field"},{"ref":"EctoQueryString.Reflection.html#primary_key/1","title":"EctoQueryString.Reflection.primary_key/1","type":"function","doc":"Return the primary key of a schema"},{"ref":"EctoQueryString.Reflection.html#primary_keys/1","title":"EctoQueryString.Reflection.primary_keys/1","type":"function","doc":"Return all the primary keys of a schema"},{"ref":"EctoQueryString.Reflection.html#schema_fields/1","title":"EctoQueryString.Reflection.schema_fields/1","type":"function","doc":"Return all the fields of the passed in Ecto.Schema The fields are returned as strings"},{"ref":"EctoQueryString.Reflection.html#source_schema/1","title":"EctoQueryString.Reflection.source_schema/1","type":"function","doc":"Find the source of an Ecto.Query"},{"ref":"readme.html","title":"EctoQueryString","type":"extras","doc":"EctoQueryString Compose an Ecto.Query with a querystring"},{"ref":"readme.html#installation","title":"EctoQueryString - Installation","type":"extras","doc":"Add :ecto_query_string to your list of dependencies in mix.exs: def deps do [ {:ecto_query_string, &quot;~&gt; 0.1.0&quot;} ] end"},{"ref":"readme.html#usage","title":"EctoQueryString - Usage","type":"extras","doc":"Say you have the following schemas: defmodule Foo do use Ecto.Schema schema &quot;foos&quot; do field(:name, :string) field(:age, :integer) has_many(:bars, Bar) end end defmodule Bar do use Ecto.Schema schema &quot;bars&quot; do field(:title, :string) field(:likes, :integer) belongs_to(:foo, Foo) end end You can do things like this: query = Ecto.Query.from(user in User) query_string = &quot;username=mrmicahcooper&amp;greater:age=18&amp;limit=10&quot; EctoQueryString.query(query, query_string) query_params = %{&quot;username&quot; =&gt; &quot;mrmicahcooper&quot;, &quot;greater:age&quot; =&gt; &quot;18&quot;, &quot;limit&quot; =&gt; &quot;10&quot;} EctoQueryString.query(query, query_params) keyword_list = [username: &quot;mrmicahcooper&quot;] EctoQueryString.query(query, keyword_list) And get: Ecto.Query.from(u0 in User, where: u0.age &gt; ^&quot;18&quot;, where: u0.username == ^&quot;mrmicahcooper&quot;, limit: ^&quot;10&quot; ) Here is the full DSL # Basic Queries &quot;name=micah&quot; =&gt; where: foo.name = ^&quot;micah&quot; &quot;name=micah,bob&quot; =&gt; where: foo.name in ^[&quot;micah&quot;, &quot;bob&quot;] &quot;!name=micah&quot; =&gt; where: foo.name != ^&quot;micah&quot; &quot;!name=micah,bob&quot; =&gt; where: foo.name not in ^[&quot;micah&quot;, &quot;bob&quot;] &quot;like:foo=bar*&quot; =&gt; where: like(x.foo, ^&quot;bar%&quot;) &quot;like:foo=*bar&quot; =&gt; where: like(x.foo, ^&quot;%bar&quot;) &quot;like:name=*micah*&quot; =&gt; where: like(foo.name, ^&quot;%micah%&quot;) &quot;ilike:name=micah*&quot; =&gt; where: ilike(foo.name, ^&quot;micah%&quot;) &quot;ilike:name=*micah&quot; =&gt; where: ilike(foo.name, ^&quot;%micah&quot;) &quot;ilike:foo=*bar*&quot; =&gt; where: ilike(x.foo, ^&quot;%bar%&quot;) &quot;less:age=99&quot; =&gt; where: foo.age &lt; 99 &quot;lessequal:age=99&quot; =&gt; where: foo.age &lt;= 99 &quot;greater:age=40&quot; =&gt; where: foo.age &gt; 40 &quot;greaterequal:age=40&quot; =&gt; where: foo.age &gt;= 40 &quot;range:age=40:99&quot; =&gt; where: foo.age &lt; 99 and foo.age &gt; 40 &quot;or:name=micah&quot; =&gt; or_where: foo.name = ^&quot;micah&quot; &quot;or:name=micah,bob&quot; =&gt; or_where: foo.name in ^[&quot;micah&quot;, &quot;bob&quot;] &quot;!or:name=bar&quot; =&gt; or_where: foo.name != ^&quot;bar&quot; &quot;!or:name=micah,bob&quot; =&gt; or_where: foo.name not in ^[&quot;bar&quot;, &quot;baz&quot;] &quot;select=foo,bar&quot; =&gt; select: [:foo, :bar] &quot;fields=foo,bar&quot; =&gt; select: [:foo, :bar] &quot;limit=.:99&quot; =&gt; limit: 99 &quot;offset=40:.&quot; =&gt; offset: 40 &quot;between=40:99&quot; =&gt; offset: 40, limit: 99 &quot;order=foo,-bar,baz&quot; =&gt; order_by: [asc: :foo, desc: :bar, asc: :baz] # Incorporating Associated Tables &quot;bars.title=micah&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.title = ^&quot;micah&quot; &quot;bars.title=micah,bob&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.title in ^[&quot;micah&quot;, &quot;bob&quot;] &quot;!bars.title=micah&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.title != ^&quot;micah&quot;) &quot;!bars.title=micah,bob&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.title not in ^[&quot;micah&quot;, &quot;bob&quot;]) &quot;like:bars.title=micah*&quot; =&gt; join: bars in assoc(foo, :bars), where: like(bars.title, ^&quot;bar%&quot;) &quot;like:bars.title=*micah&quot; =&gt; join: bars in assoc(foo, :bars), where: like(bars.title, ^&quot;%bar&quot;) &quot;like:bars.title=*micah*&quot; =&gt; join: bars in assoc(foo, :bars), where: like(bars.title, ^&quot;%bar%&quot;) &quot;ilike:bars.title=micah*&quot; =&gt; join: bars in assoc(foo, :bars), where: ilike(bars.title, ^&quot;micah%&quot;) &quot;ilike:bars.title=*micah&quot; =&gt; join: bars in assoc(foo, :bars), where: ilike(bars.title, ^&quot;%micah&quot;) &quot;ilike:bars.title=*micah* &quot; =&gt; join: bars in assoc(foo, :bars), where: ilike(bars.title, ^&quot;%micah%&quot;) &quot;less:bars.likes=99&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.likes &lt; 99 &quot;lessequal:bars.likes=99&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.likes &lt;= 99 &quot;greater:bars.likes=99&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.likes &gt; 99 &quot;greaterequal:bars.likes=99&quot;=&gt; join: bars in assoc(foo, :bars), where: bars.likes &gt;= 99 &quot;range:bars.likes=40:99&quot; =&gt; join: bars in assoc(foo, :bars), where: bars.likes&lt; 99 and bars.likes &gt; 40 &quot;or:bars.title=micah&quot; =&gt; join: bars in assoc(foo, :bars), or_where: bars.title == ^&quot;micah&quot; &quot;or:bars.title=micah,bob&quot; =&gt; join: bars in assoc(foo, :bars), or_where: bars.title in ^[&quot;micah&quot;, &quot;bob&quot; &quot;!or:bars.title=micah&quot; =&gt; join: bars in assoc(foo, :bars), or_where: bars.title != ^&quot;micah&quot; &quot;!or:bars.title=micah,bob&quot; =&gt; join: bars in assoc(foo, :bars), or_where: bars.title not in ^[&quot;micah&quot;, &quot;bob&quot; &quot;select=email,bars.title&quot; =&gt; join: bars in assoc(foo, :bars), select: [{:bars, [:title]}, :email], preload: [:bars] # Maps and keyword lists are supported too %{&quot;ilike:foo&quot; =&gt; &quot;*bar*&quot;} =&gt; where: ilike(x.foo, ^&quot;%bar%&quot;) [name: &quot;micah&quot;] =&gt; where: foo.name = ^&quot;micah&quot;"},{"ref":"readme.html#caveats","title":"EctoQueryString - Caveats","type":"extras","doc":"When using select - In order to hydrate the schema, you must always at least select=id from every schema. Even nested schemas would need at least select=id,foos.id When using order - You cannot not (currently) order by nested fields."}]